/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * stacks * near  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. To access native functionality, use the protocol without the v2 prefix * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/v1/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * stacks/mainnet - [Stacks API Documentation](https://blockstack.github.io/stacks-blockchain-api/) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc)  A full URL example: https://ubiquity.api.blockdaemon.com/_**bitcoin/mainnet**  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.gitlab.blockdaemon.ubiquity.model;

import java.util.Objects;
import java.util.Arrays;
import java.util.Map;
import java.util.HashMap;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.gitlab.blockdaemon.ubiquity.model.Currency;
import com.gitlab.blockdaemon.ubiquity.model.Utxo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.gitlab.blockdaemon.ubiquity.invoker.JSON;


/**
 * Transfer of currency in the UTXO model
 */
@ApiModel(description = "Transfer of currency in the UTXO model")
@JsonPropertyOrder({
  MultiTransfer.JSON_PROPERTY_INPUTS,
  MultiTransfer.JSON_PROPERTY_OUTPUTS,
  MultiTransfer.JSON_PROPERTY_CURRENCY,
  MultiTransfer.JSON_PROPERTY_TOTAL_IN,
  MultiTransfer.JSON_PROPERTY_TOTAL_OUT,
  MultiTransfer.JSON_PROPERTY_UNSPENT
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class MultiTransfer {
  public static final String JSON_PROPERTY_INPUTS = "inputs";
  private List<Utxo> inputs = new ArrayList<>();

  public static final String JSON_PROPERTY_OUTPUTS = "outputs";
  private List<Utxo> outputs = new ArrayList<>();

  public static final String JSON_PROPERTY_CURRENCY = "currency";
  private Currency currency;

  public static final String JSON_PROPERTY_TOTAL_IN = "total_in";
  private String totalIn;

  public static final String JSON_PROPERTY_TOTAL_OUT = "total_out";
  private String totalOut;

  public static final String JSON_PROPERTY_UNSPENT = "unspent";
  private String unspent;


  public MultiTransfer inputs(List<Utxo> inputs) {
    this.inputs = inputs;
    return this;
  }

  public MultiTransfer addInputsItem(Utxo inputsItem) {
    this.inputs.add(inputsItem);
    return this;
  }

   /**
   * Get inputs
   * @return inputs
  **/
  @ApiModelProperty(required = true, value = "")
  @JsonProperty(JSON_PROPERTY_INPUTS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public List<Utxo> getInputs() {
    return inputs;
  }


  @JsonProperty(JSON_PROPERTY_INPUTS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setInputs(List<Utxo> inputs) {
    this.inputs = inputs;
  }


  public MultiTransfer outputs(List<Utxo> outputs) {
    this.outputs = outputs;
    return this;
  }

  public MultiTransfer addOutputsItem(Utxo outputsItem) {
    this.outputs.add(outputsItem);
    return this;
  }

   /**
   * Get outputs
   * @return outputs
  **/
  @ApiModelProperty(required = true, value = "")
  @JsonProperty(JSON_PROPERTY_OUTPUTS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public List<Utxo> getOutputs() {
    return outputs;
  }


  @JsonProperty(JSON_PROPERTY_OUTPUTS)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setOutputs(List<Utxo> outputs) {
    this.outputs = outputs;
  }


  public MultiTransfer currency(Currency currency) {
    this.currency = currency;
    return this;
  }

   /**
   * Get currency
   * @return currency
  **/
  @ApiModelProperty(required = true, value = "")
  @JsonProperty(JSON_PROPERTY_CURRENCY)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public Currency getCurrency() {
    return currency;
  }


  @JsonProperty(JSON_PROPERTY_CURRENCY)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setCurrency(Currency currency) {
    this.currency = currency;
  }


  public MultiTransfer totalIn(String totalIn) {
    this.totalIn = totalIn;
    return this;
  }

   /**
   * Integer string in smallest unit (Satoshis)
   * @return totalIn
  **/
  @ApiModelProperty(example = "133337", required = true, value = "Integer string in smallest unit (Satoshis)")
  @JsonProperty(JSON_PROPERTY_TOTAL_IN)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getTotalIn() {
    return totalIn;
  }


  @JsonProperty(JSON_PROPERTY_TOTAL_IN)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setTotalIn(String totalIn) {
    this.totalIn = totalIn;
  }


  public MultiTransfer totalOut(String totalOut) {
    this.totalOut = totalOut;
    return this;
  }

   /**
   * Integer string in smallest unit (Satoshis)
   * @return totalOut
  **/
  @ApiModelProperty(example = "133337", required = true, value = "Integer string in smallest unit (Satoshis)")
  @JsonProperty(JSON_PROPERTY_TOTAL_OUT)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getTotalOut() {
    return totalOut;
  }


  @JsonProperty(JSON_PROPERTY_TOTAL_OUT)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setTotalOut(String totalOut) {
    this.totalOut = totalOut;
  }


  public MultiTransfer unspent(String unspent) {
    this.unspent = unspent;
    return this;
  }

   /**
   * Integer string in smallest unit (Satoshis)
   * @return unspent
  **/
  @ApiModelProperty(example = "133337", required = true, value = "Integer string in smallest unit (Satoshis)")
  @JsonProperty(JSON_PROPERTY_UNSPENT)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getUnspent() {
    return unspent;
  }


  @JsonProperty(JSON_PROPERTY_UNSPENT)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setUnspent(String unspent) {
    this.unspent = unspent;
  }


  /**
   * Return true if this multi_transfer object is equal to o.
   */
  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MultiTransfer multiTransfer = (MultiTransfer) o;
    return Objects.equals(this.inputs, multiTransfer.inputs) &&
        Objects.equals(this.outputs, multiTransfer.outputs) &&
        Objects.equals(this.currency, multiTransfer.currency) &&
        Objects.equals(this.totalIn, multiTransfer.totalIn) &&
        Objects.equals(this.totalOut, multiTransfer.totalOut) &&
        Objects.equals(this.unspent, multiTransfer.unspent);
  }

  @Override
  public int hashCode() {
    return Objects.hash(inputs, outputs, currency, totalIn, totalOut, unspent);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MultiTransfer {\n");
    sb.append("    inputs: ").append(toIndentedString(inputs)).append("\n");
    sb.append("    outputs: ").append(toIndentedString(outputs)).append("\n");
    sb.append("    currency: ").append(toIndentedString(currency)).append("\n");
    sb.append("    totalIn: ").append(toIndentedString(totalIn)).append("\n");
    sb.append("    totalOut: ").append(toIndentedString(totalOut)).append("\n");
    sb.append("    unspent: ").append(toIndentedString(unspent)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

